<template>
  <v-container>
    <v-card
      class="mx-auto px-7 py-10 rounded-b-lg rounded-t-0"
      max-width="800"
      outlined
      elevation="3"
    >
      <h2 class="text-center text-headline mb-6">Isi Data Warga Anda</h2>
      <v-form
        ref="form"
        v-model="valid"
        @submit.prevent="submit"
        lazy-validation
      >
        <v-text-field
          v-model="nama"
          class="mb-4"
          :rules="[(v) => !!v || 'Nama wajib diisi']"
          label="Nama"
          outlined
          required
        ></v-text-field>

        <v-text-field
          v-model="nik"
          name="nik"
          class="mb-4"
          :counter="16"
          @keypress="cekNumber"
          :rules="[(v) => !!v || 'NIK wajib diisi', rules.nik]"
          label="NIK"
          type="number"
          outlined
          required
        ></v-text-field>

        <v-text-field
          v-model="noKK"
          name="kk"
          class="mb-4"
          :counter="16"
          @keypress="cekNumber"
          :rules="[(v) => !!v || 'Nomor Kartu Keluarga wajib diisi', rules.kk]"
          label="Nomor Kartu Keluarga"
          type="number"
          outlined
          required
        ></v-text-field>

        <v-file-input
          show-size
          prepend-icon=""
          :rules="[
            (v) => !!v || 'Foto KTP wajib diisi',
            rules.photoSize,
            rules.photoType,
          ]"
          accept=".jpg,.jpeg,.png,.bmp"
          outlined
          label="Foto KTP"
        >
        </v-file-input>

        <v-file-input
          show-size
          prepend-icon=""
          :rules="[
            (v) => !!v || 'Foto KK wajib diisi',
            rules.photoSize,
            rules.photoType,
          ]"
          accept=".jpg,.jpeg,.png,.bmp"
          outlined
          label="Foto Kartu Keluarga"
        >
        </v-file-input>

        <v-text-field
          v-model="umur"
          class="col-12 col-sm-6"
          :rules="[(v) => !!v || 'Umur wajib diisi', rules.umur]"
          label="Umur"
          type="number"
          outlined
          required
        ></v-text-field>

        <v-select
          v-model="select"
          :items="jkitems"
          :rules="[(v) => !!v || 'Jenis kelamin wajib diisi']"
          label="Jenis Kelamin"
          outlined
          required
        ></v-select>

        <v-text-field
          v-model="alamat"
          class="mb-4"
          :rules="[(v) => !!v || 'Alamat wajib diisi', rules.alamat]"
          :counter="255"
          label="Alamat"
          outlined
          rows="1"
          no-resize
          auto-grow
        ></v-text-field>

        <v-text-field
          v-model="rt"
          @keypress="cekNumber"
          class="col-6"
          :rules="[(v) => !!v || 'RT wajib diisi']"
          label="RT"
          type="number"
          outlined
          required
        ></v-text-field>
        <v-text-field
          v-model="rw"
          @keypress="cekNumber"
          class="col-6"
          :rules="[(v) => !!v || 'RW wajib diisi']"
          label="RW"
          type="number"
          outlined
          required
        ></v-text-field>

        <v-text-field
          v-model="PengSebelumPandemi"
          @keypress="cekNumber"
          class="col-12 col-sm-6 mb-4 mb-sm-0"
          :rules="[(v) => !!v || 'Penghasilan Sebelum Pandemi wajib diisi']"
          counter
          label="Penghasilan Sebelum Pandemi"
          type="number"
          prefix="Rp."
          outlined
          required
        ></v-text-field>

        <v-text-field
          v-model="PengSetelahPandemi"
          @keypress="cekNumber"
          class="col-12 col-sm-6"
          :rules="[(v) => !!v || 'Penghasilan Setelah Pandemi wajib diisi']"
          counter
          label="Penghasilan Setelah Pandemi"
          type="number"
          prefix="Rp."
          outlined
          required
        ></v-text-field>

        <v-select
          v-model="alasanTerpilih"
          :items="alasanList"
          :rules="[(v) => !!v || 'Alasan wajib diisi']"
          label="Alasan membutuhkan bantuan"
          placeholder="Pilih salah satu"
          :menu-props="{ overflowX: true }"
          attach
          outlined
          auto
          required
        ></v-select>

        <v-scale-transition>
          <v-text-field
            v-model="alasanLainnya"
            v-if="alasanTerpilih == 'Lainnya'"
            class="mt-n3"
            :rules="[(v) => !!v || 'Alasan wajib diisi']"
            outlined
            required
          ></v-text-field>
        </v-scale-transition>

        <v-checkbox
          v-model="check"
          class="mb-6"
          id="agreement"
          :rules="[(v) => !!v || 'Harap setujui untuk melanjutkan!']"
          :ripple="false"
          required
        >
          <template v-slot:label>
            Saya menyatakan bahwa data yang diisikan adalah benar dan siap
            mempertanggungjawabkan apabila ditemukan ketidaksesuaian dalam data
            tersebut.
          </template>
        </v-checkbox>

        <div v-show="!valid" class="error--text my-2 text-subtitle">
          <span> Mohon pastikan data telah terisi seluruhnya! </span>
        </div>
        <div class="text-center text-md-left">
          <v-btn
            :disabled="!valid"
            :block="$vuetify.breakpoint.mobile"
            :loading="loadingButton"
            elevation="3"
            color="success"
            type="submit"
          >
            Kirim
          </v-btn>
          <v-btn
            color="warning"
            :block="$vuetify.breakpoint.mobile"
            :loading="loadingButton"
            elevation="3"
            @click="reset"
          >
            Reset Form
          </v-btn>
        </div>
      </v-form>
    </v-card>
  </v-container>
</template>

<script>
export default {
  data: () => ({
    valid: true,
    loadingButton: false,
    nama: "",
    nik: "",
    noKK: "",
    umur: "",
    alamat: "",
    jenisKelamin: "",
    rt: "",
    rw: "",
    PengSebelumPandemi: "",
    PengSetelahPandemi: "",
    alasanTerpilih: null,
    alasanLainnya: "",
    alasanList: [
      "Kehilangan Pekerjaan",
      "Kepala keluarga terdampak atau korban Covid",
      "Tergolong fakir/miskin semenjak sebelum Covid",
      "Lainnya",
    ],
    select: null,
    jkitems: ["Laki-Laki", "Perempuan"],
    check: false,
    messagesFoto: [
      "Foto tidak boleh lebih dari 2MB",
      "Format file PNG/JPG/JPEG/BMP",
    ],
    rules: {
      photoSize: (v) => !v || v.size <= 2000000 || "Ukuran file terlalu besar",
      photoType: (v) =>
        !v ||
        ["image/png", "image/jpeg", "image/jpeg", "image/bmp"].indexOf(
          v.type
        ) >= 0 ||
        "Format file salah",
      umur: (v) => (v && v >= 25) || "Umur harus 25 atau keatas",
      nik: (v) => (v && v.length == 16) || "NIK harus berjumlah 16 digit",
      kk: (v) => (v && v.length == 16) || "Nomor KK harus berjumlah 16 digit",
      alamat: (v) =>
        (v && v.length <= 255) || "Alamat tidak boleh lebih dari 255 karakter",
    },
  }),
  computed: {
    inputedData() {
      return {
        nama: this.nama,
        nik: this.nik,
        noKK: this.noKK,
        umur: this.umur,
        alamat: this.alamat,
        jenisKelamin: this.jenisKelamin,
        rt: this.rt,
        rw: this.rw,
        PengSebelumPandemi: this.PengSebelumPandemi,
        PengSetelahPandemi: this.PengSetelahPandemi,
        alasan: this.alasan,
      };
    },
    alasan() {
      if (this.alasanTerpilih && this.alasanTerpilih == "Lainnya") {
        return this.alasanLainnya;
      }

      return this.alasanTerpilih;
    },
  },
  methods: {
    sleep(ms) {
      return new Promise((resolve) => setTimeout(resolve, ms));
    },

    randomNumber(min, max) {
      return Math.random() * (max - min) + min;
    },

    async submit() {
      if (this.$refs.form.validate()) {
        let time = Math.floor(this.randomNumber(1400, 1600));
        console.log({
          responseTime: time,
          data: this.inputedData,
        });
        this.loadingButton = true;
        await this.sleep(time);
        if (time >= 1500) {
          this.loadingButton = false;
        } else {
          this.loadingButton = false;
          this.$router.push({
            name: "Hasil",
            params: {
              savedForm: true,
            },
          });
        }
      }
    },
    reset() {
      this.$refs.form.reset();
    },

    cekNumber(event) {
      if (
        (event.which != 8 && event.which != 0 && event.which < 48) ||
        event.which > 57
      ) {
        event.preventDefault();
      }

      if (event.target.name == "nik" || event.target.name == "kk") {
        if (event.target.value.length >= 16) {
          event.preventDefault();
        }
      }
    },
  },
  beforeMount() {
    document.title = this.$route.meta.title;
  },
};
</script>